#include "bits/stdc++.h"

using namespace std;

int main() {
  int N;
  long long T;
  cin >> N >> T;
  vector <long long> blocks(N);
  for (int i=0; i<N; i++) cin >> blocks[i];

  map <long long, pair <int, vector <long long>>> solutions;
  solutions[1] = {0, {}};

  for (long long block : blocks) {
    auto solutions_snapshot = solutions;
    for (auto [number, result] : solutions_snapshot) {
      auto [len, list] = result;
      long long candidate = number * block;
      if (T % candidate == 0) {
        if (solutions.find(candidate) == solutions.end() or
          solutions[candidate].first > len + 1) {
            vector <long long> new_list = list;
            new_list.push_back(block);
            solutions[candidate] = {len+1, new_list};
          }
      }
    }
  }

  if (solutions.find(T) == solutions.end()) {
    cout << "NIE\n";
    return 0;
  } else {
    auto [len, list] = solutions[T];
    cout << len << "\n";
    for (long long ele : list) cout << ele << " ";
    cout << "\n";
  }
}
